# OE: conditional switches
#
#(ie. use with rpm --rebuild):
#
#	--with debug	Compile with debugging code
# 
#  enable build with debugging code: will _not_ strip away any debugging code,
#  will _add_ -g3 to CFLAGS, will _add_ --enable-maintainer-mode to 
#  configure.

%define build_debug 0

# commandline overrides:
# rpm -ba|--rebuild --with 'xxx'
%{?_with_debug: %{expand: %%define build_debug 1}}

%if %{build_debug}
# disable build root strip policy
%define __spec_install_post /usr/lib/rpm/brp-compress || :

# This gives extra debuggin and huge binaries
%{expand:%%define optflags %{optflags} %([ ! $DEBUG ] && echo '-g3')}
%endif

%define rname subversion
%define rversion 0.18.1
%define revision 5118
%define	major 0
%define libname	%mklibname %{rname} %{major}

#Module-Specific definitions
%define mod_version %{rversion}
%define mod_name mod_dav_svn
%define mod_conf 46_%{mod_name}.conf
%define mod_so %{mod_name}.so

%define neon_version 0.23.8
%define swig_version 1.3.16

#New ADVX macros
%define ADVXdir %{_datadir}/ADVX
%{expand:%(cat %{ADVXdir}/ADVX-build)}
%{expand:%%global ap_version %(%{apxs} -q ap_version)}

Summary:	A Concurrent Versioning system similar to but better than CVS.
Name:		%{rname}
Version:	%{rversion}
Release:	0.r%{revision}.1mdk
License:	BSD
Group:		Development/Other
URL:		http://subversion.tigris.org
Source0:	%{rname}-r%{revision}.tar.bz2
Source1:	%{mod_conf}.conf.bz2
Source2:	rcsparse.py.bz2
Patch0:		cvs2svn.patch.bz2
Patch1:		python_swig_setup.py.patch.bz2
Patch2:		subversion-0.15.patch.bz2

Requires:	libdb4.0 >= 4.0.14
Requires:	expat
Requires:	libneon0.23 >= %{neon_version}

#Requires: /sbin/install-info

BuildPreReq:	autoconf2.5 >= 2.54
BuildPreReq:	db4-devel >= 4.0.14
BuildPreReq:	expat-devel
BuildPreReq:	gdbm-devel
BuildPreReq:	libtool >= 1.4.2
BuildPreReq:	libneon0.23-devel = %{neon_version}
#BuildPreReq:	swig-devel = %{swig_version}
BuildPreReq:	openssl-devel
BuildPreReq:	python
BuildPreReq:	python-devel
BuildPreReq:	texinfo
BuildPreReq:	zlib-devel
BuildPreReq:	chrpath
BuildRoot:	%{_tmppath}/%{name}-%{version}

#Standard ADVX requires
Prereq:		%{ap_name} = %{ap_version}
Prereq:		%{ap_name}-conf
BuildRequires:  ADVX-build >= 1.2
BuildRequires:  %{ap_name}-devel >= 2.0.43-5mdk

%description
Subversion is a concurrent version control system which enables one or more
users to collaborate in developing and maintaining a hierarchy of files and
directories while keeping a history of all changes.  Subversion only stores the
differences between versions, instead of every complete file.  Subversion also
keeps a log of who, when, and why changes occured.

As such it basically does the same thing CVS does (Concurrent Versioning
System) but has major enhancements compared to CVS and fixes a lot of the
annoyances that CVS users face.

This package contains the common files required by subversion clients and
servers.

You can build %{name} with some conditional build swithes;

(ie. use with rpm --rebuild):
--with debug   Compile with debugging code

%package -n	%{libname}
Summary:	Common libraries for Subversion
Group:		System/Libraries
Requires:	libapr0 >= %{ap_version}
Provides:	%{libname} = %{rversion}-%{release}

%description -n	%{libname}
This package contains all the common libraries required to run
subversion components.

%package	client-common
Summary:	Common Client Libs for Subversion
Group:		Development/Other
Requires:	%{libname} = %{rversion}-%{release}

%description	client-common
This package contains the common libraries required to run a
subversion client. You'll want to install the
subversion-client-dav or subversion-client-local to access network
or local repositories, respectfully.

%package	client-dav
Summary:	Network Repository Access for the Subversion Client
Group:		Development/Other
Requires:	%{libname} = %{rversion}-%{release}
Requires:	%{rname}-client-common = %{rversion}-%{release}
Requires:	libneon0.23 >= %{neon_version}

%description	client-dav
This package contains the libraries required to allow the
subversion client (`svn') to access network subversion
repositories.

%package	client-local
Summary:	Local Repository Access for the Subversion Client
Group:		Development/Other
Requires:	%{libname} = %{rversion}-%{release}
Requires:	%{rname}-client-common = %{rversion}-%{release}
Requires:	%{rname}-repos = %{rversion}-%{release}

%description	client-local
This package contains the libraries required to allow the
subversion client (`svn') to access local subversion repositories.

%package	repos
Summary:	Local Repository Access for Subversion
Group:		Development/Other
Requires:	%{libname} = %{rversion}-%{release}
Requires:	libdb4.0 >= 4.0.14

%description	repos
This package contains the libraries required to allow subversion
to access local repositories. In addition, subversion-client-local
is required for the subversion client (`svn') to utilize these
repositories directly.

This package also includes the `svnadmin' and `svnlook' programs.

%package -n	%{libname}-devel
Summary:	Subversion Headers/Libraries for Development
Group:		Development/Other
Requires:	%{libname} = %{rversion}-%{release}
Provides:	lib%{rname}-devel = %{rversion}-%{release}

%description -n %{libname}-devel
This package contains the header files and linker scripts for
subversion libraries.

%package -n	%{libname}-static-devel
Summary:	Static Subversion Libraries for Development
Group:		Development/Other
Requires:	%{libname} = %{rversion}-%{release}

%description -n	%{libname}-static-devel
This package contains the static files for subversion libraries.

#%package	python
#Summary:	Python Bindings for Subversion
#Group:		Development/Other
#Requires:	%{libname} = %{rversion}-%{release}
#Requires:	python >= 2.2.0
#Requires:	swig >= %{swig_version}
#
#%description	python
#This package contains the files necessary to use the subversion
#library functions within python scripts. This will also install a
#number of utility scripts, including `cvs2svn', a CVS repository
#converter for subversion.

%package -n	%{ap_name}-%{mod_name}
Summary:	Subversion Server DSO Module for %{ap_name}
Version:	%{ap_version}_%{rversion}
Group:		System/Servers
Requires:	%{libname} = %{rversion}-%{release}
Requires:	%{ap_name}-mod_dav >= %{ap_version}
Requires:	%{rname}-repos = %{rversion}-%{release}
Provides: 	ADVXpackage
Provides:	AP20package

%description -n	%{ap_name}-%{mod_name}
Subversion is a concurrent version control system which enables
one or more users to collaborate in developing and maintaining a
hierarchy of files and directories while keeping a history of all
changes. Subversion only stores the differences between versions,
instead of every complete file. Subversion also keeps a log of
who, when, and why changes occured.

As such it basically does the same thing CVS does (Concurrent
Versioning System) but has major enhancements compared to CVS and
fixes a lot of the annoyances that CVS users face.

This package contains the apache2 server extension DSO for running
a subversion server.

%prep
%setup -q -n %{rname}-r%{revision}
%patch0 -p1
%patch1 -p1
%patch2 -p0

%build
export WANT_AUTOCONF_2_5="1"

./autogen.sh

%configure2_5x \
%if %{build_debug}
    --enable-maintainer-mode \
%endif
    --with-apxs=%{apxs} \
    --with-apr=%{_prefix} \
    --with-apr-util=%{_prefix} \
    --with-neon=%{_prefix} \
    --with-berkeley-db=%{_prefix} \
    --with-xmlrpc-epi=%{_prefix} \
    --enable-shared \
    --enable-dso \
    --disable-mod-activation

#    --with-swig=%{_prefix} \

%make

#cd subversion/bindings/swig/python
#%{_bindir}/python setup.py build

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

make DESTDIR="%{buildroot}" install

# workaround %%ADVXinstlib
install -d %{buildroot}%{ap_extralibs}
mv -f %{buildroot}%{ap_libexecdir}/%{mod_so} %{buildroot}%{ap_extralibs}/%{mod_so}

%ADVXinstconf %{SOURCE1} %{mod_conf}

# copy everything in tools into a share directory
#mkdir -p %{buildroot}/%{_datadir}/%{name}-%{version}
#cp -r tools %{buildroot}/%{_datadir}/%{name}-%{version}/
#
# cvs2svn
#pushd subversion/bindings/swig/python
#    %{_bindir}/python setup.py install --prefix %{buildroot}%{_prefix}
#popd
#
#install -m755 tools/cvs2svn/cvs2svn.py %{buildroot}%{_bindir}/cvs2svn
#cp %{SOURCE2} %{buildroot}%{_libdir}/python2.2/site-packages/svn

# fix the stupid rpath stuff...
find %{buildroot}%{_bindir} -type f | xargs chrpath -d
find %{buildroot}%{_libdir} -type f -name "*so" | xargs chrpath -d


%post -n %{libname}
/sbin/ldconfig
%_install_info svn-design.info
%_install_info svn-handbook.info

%preun -n %{libname}
%_install_info svn-design.info
%_install_info svn-handbook.info

%postun -n %{libname} -p /sbin/ldconfig

%post -n %{libname}-devel -p /sbin/ldconfig
%postun -n %{libname}-devel -p /sbin/ldconfig

%post -n %{name}-repos -p /sbin/ldconfig
%postun -n %{name}-repos -p /sbin/ldconfig

%post -n %{name}-client-common -p /sbin/ldconfig
%postun -n %{name}-client-common -p /sbin/ldconfig

%post -n %{name}-client-local -p /sbin/ldconfig
%postun -n %{name}-client-local -p /sbin/ldconfig

%post -n %{name}-client-dav -p /sbin/ldconfig
%postun -n %{name}-client-dav -p /sbin/ldconfig

%post -n %{ap_name}-%{mod_name}
%ADVXpost

%postun -n %{ap_name}-%{mod_name}
%ADVXpost

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files -n %{libname}
%defattr(-,root,root)
%doc BUGS COMMITTERS COPYING HACKING IDEAS INSTALL PORTING README
%doc doc subversion/LICENSE
%{_libdir}/libsvn_auth-*.so
%{_libdir}/libsvn_auth-*.so.*
%{_libdir}/libsvn_delta-*.so
%{_libdir}/libsvn_delta-*so.*
%{_libdir}/libsvn_fs-*.so
%{_libdir}/libsvn_fs-*so.*
%{_libdir}/libsvn_subr-*.so
%{_libdir}/libsvn_subr-*so.*
%{_libdir}/libsvn_wc-*.so
%{_libdir}/libsvn_wc-*so.*
%{_mandir}/man1/svnadmin.*
%{_infodir}/*

%files repos
%defattr(-,root,root)
%{_bindir}/svnadmin
%{_bindir}/svnlook
%{_bindir}/svnserve
%{_libdir}/libsvn_repos-*.so
%{_libdir}/libsvn_repos-*.so.*
%{_libdir}/libsvn_ra_svn-*.so
%{_libdir}/libsvn_ra_svn-*.so.*

%files client-common
%defattr(-,root,root)
%{_bindir}/svn
%{_bindir}/svnversion
%{_libdir}/libsvn_client-*.so
%{_libdir}/libsvn_client*so.*
%{_libdir}/libsvn_ra-*.so
%{_libdir}/libsvn_ra-*so.*
%{_mandir}/man1/svn.*

%files client-local
%defattr(-,root,root)
%{_libdir}/libsvn_ra_local-*.so
%{_libdir}/libsvn_ra_local-*so.*

%files client-dav
%defattr(-,root,root)
%{_libdir}/libsvn_ra_dav-*.so
%{_libdir}/libsvn_ra_dav-*so.*

#%files python
#%defattr(-,root,root)
#%{_bindir}/cvs2svn
#%{_libdir}/libsvn_swig*so
#%{_libdir}/libsvn_swig*so.*
#%{_libdir}/python2*/site-packages/svn
#%{_datadir}/%{name}-%{version}/tools

%files -n %{libname}-devel
%defattr(-,root,root)
%{_bindir}/svn-config
%{_libdir}/libsvn*.la
#%{_libdir}/libsvn*so
%{_includedir}/subversion-1

%files -n %{libname}-static-devel
%defattr(-,root,root)
%{_libdir}/libsvn*.a

%files -n %{ap_name}-%{mod_name}
%defattr(-,root,root)
#%doc www/*
%config(noreplace) %{ap_confd}/%{mod_conf}
%{ap_extralibs}/%{mod_so}
#%{ap_webdoc}/*

%changelog
* Tue Mar 04 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.18.1-0.r5118.1mdk
- 0.18.1
- use the %%mklibname macro
- rebuilt against latest buildrequires
- make rpmlint a little happier...

* Sat Feb 22 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 0.17.1-0.r4503.2mdk
- fix requires (libdb4.0, not db4)

* Sat Feb 08 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.17.1-0.r4503.1mdk
- 0.17.1
- added fixes by Oliver Lemke <olemke@core-dump.net>, thanks man!
- rediffed P0

* Tue Jan 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.16-0.r3987.6mdk
- rebuilt for apache v2.0.44

* Mon Jan 20 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.16-0.r3987.5mdk
- fix buildrequires apache2-devel >= 2.0.43-5mdk, as 
  pointed out by Olivier Thauvin

* Sun Jan 19 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.16-0.r3987.4mdk
- da capo

* Sat Jan 18 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.16-0.r3987.3mdk
- rebuilt against rebuilt buildrequires

* Mon Jan 13 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.16-0.r3987.2mdk
- it's much easier to upload when increasing the release number ;)
- Rebuilt with the new apache-devel that uses /usr/sbin/apxs2 and
  /usr/include/apache2

* Fri Dec 06 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.16-0.r3987.1mdk
- new version
- misc spec file fixes

* Sun Nov 10 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.15-0.r3687.1mdk
- new version
- added P2 by Robert Schiele

* Sat Nov 09 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.14.5-0.r3578.4mdk
- enable build with debugging code, used ideas from Han Boetes and his
  fluxbox package, but the RedHat way. rpm --rebuild --with debug 
  subversion-0.14.5-0.r3578.4mdk.src.rpm will _not_ strip away any debugging code,
  will _add_ -g3 to CFLAGS, will _add_ --enable-maintainer-mode to 
  configure.

* Wed Nov 06 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.14.5-0.r3578.3mdk
- fix this broken package by totally ignoring Mr. Lint for now

* Tue Nov 05 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.14.5-0.r3578.2mdk
- added the client-local and client-dav subpackages to conform more to 
  the provided rpm spec file (and their descriptions)
- misc spec file fixes

* Fri Nov 01 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.14.5-0.r3578.1mdk
- used parts of the spec file by David Summers and parts of the
  provided spec file by Michael Ballbach 
- cannot build the python and swig stuff until we have swig v1.3.16
- libifiction
- initial cooker contrib (first attempt to build this beast...)
